package monitor;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
/**
 * Classe persona.
 *
 * <p>Title: Progetto di Sistemi 2, Ascensori con i Monitor</p>
 * <p>Description: Implementazione di un palazzo con due risorse ascensori, ai quali le persone accedono in concorrenza.</p>
 * <p>Company: </p>
 * @author Alessandro Boschi, Andrea Fabrizi, Alessandro Ronchi, Angelo Scozzoli
 * @version 1.0
 */

public class persona extends Thread
{
    public int piano_from, piano_to, direzione, usr_id, id_asc, girato, Width, Height, xpartenza, x;
    //girato 0 sinistra 1 destra
    public monitor_ascensori mon;
    public String imagefile;
    public JLabel PersonaLabel, TextLabel;
    public Image Immagine;
    public ImageIcon PersonaIcon;
    public boolean free;
    public boolean muove;
    public int gif;

    /**
     * Costruttore della classe utente.
     * @param monglob Semaforo globale.
     * @param n_piani il numero di piani del palazzo (necessario per la generazione random)
     * @param usr_id id di riconoscimento dell'utente.
     */
    public persona(int npiani,monitor_ascensori monglob,int usr_id,int piano_from, int direzione)
    {
	this.usr_id=usr_id;
	id_asc=0;
	this.piano_from = piano_from;
	girato=((int) (Math.random() * 2));
	xpartenza= (((int) (Math.random()*293))+190);
	this.direzione=direzione;
	muove = false;
	gif=((int) (Math.random() * 20)+1);
	imagefile=("pass"+gif+"_"+girato+".gif");
	if (direzione==1)//calcola il piano di arrivo in base a quello di partenza e alla direzione
	    piano_to= (int) (Math.random() * piano_from);
	else
	    piano_to= ((int) (Math.random() * ((npiani-piano_from)-1))+(piano_from+1));

	TextLabel = new JLabel();
	TextLabel.setText(String.valueOf(piano_to));
	TextLabel.setBounds(-10, -10, 10, 10);
	Font font1 = new Font("Verdana", Font.PLAIN, 10);
	TextLabel.setFont(font1);
	mon=monglob;
    }

    public void run()
    {
	mon.iniziapers(this);

    }
}
