package monitor;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
 * Classe che gestisce tutta la grafica del progetto, estendendo la superclasse JApplet
 * delle librerie Swing
 *
 * <p>Title: Progetto di Sistemi 2, Ascensori con i Monitor</p>
 * <p>Description: Implementazione di un palazzo con due risorse ascensori, ai quali le persone accedono in concorrenza.</p>
 * <p>Company: </p>
 * @author Alessandro Boschi, Andrea Fabrizi, Alessandro Ronchi, Angelo Scozzoli
 * @version 1.0
 */

public class Applet extends JApplet implements ActionListener {
    int frameNumber1 = -1;
    int frameNumber = -1;
    int framePerson = -1;
    javax.swing.Timer timer;
    boolean frozen = false;

    JLayeredPane layeredPane;
    JLabel bgLabel, fgLabel, Asc1Label, Asc2Label, Asc1LabelText, Asc2LabelText ;
    ImageIcon FrecciaIconSu, FrecciaIconGiu;
    int fgHeight, fgWidth, ascIconWidth, ascIconHeight;

    static String fgFile = "pers1dx.gif";
    static String sfondo = "background.jpg";
    static String asce1 = "ascens.gif";
    static String asce2 = "ascensr.gif";

    public int maxpersone = 10000;
    public int porta1 = 190;
    public int porta2 = 238;
    public int porta3 = 290;
    public int porta4 = 336;
    public int porta5 = 386;
    public int porta6 = 435;
    public int porta7 = 483;


    public int piani[] = {502,458,411,366,320,275,229,184,137,89};
    public int ascensore1from = piani[0];  // l'ascensore parte dal piano terra
    public int ascensore1to = piani[0];  // l'ascensore parte dal piano terra
    public int ascensore2from = piani[0];  // l'ascensore parte dal piano terra
    public int ascensore2to = piani[0];  // l'ascensore parte dal piano terra
    public int doveascensore1 = 1000;
    public int doveascensore2 = 1000;
    public int dentroa1 = 0;
    public int dentroa2 = 0;
    public int numpersone = 0;
    public int npiani = 10;
    public int j;
    private int pianofrom;

    JLayeredPane jPanel1 = new JLayeredPane();
    JToggleButton  Auto = new JToggleButton();
    JButton jButton1giu = new JButton();
    JButton jButton2su = new JButton();
    JButton jButton2giu = new JButton();
    JButton jButton3su = new JButton();
    JButton jButton3giu = new JButton();
    JButton jButton4su = new JButton();
    JButton jButton4giu = new JButton();
    JButton jButton5su = new JButton();
    JButton jButton5giu = new JButton();
    JButton jButton6su = new JButton();
    JButton jButton6giu = new JButton();
    JButton jButton7su = new JButton();
    JButton jButton7giu = new JButton();
    JButton jButton8su = new JButton();
    JButton jButton8giu = new JButton();
    JButton jButton9su = new JButton();
    JButton jButton9giu = new JButton();
    JButton jButton10su = new JButton();
    BorderLayout borderLayout1 = new BorderLayout();

    int direzione;
    Image PersonaImage;
    JLabel PersonaLabel;
    persona persone[];
    ImageIcon tempicon;

    public monitor_ascensori monitor_globale=new monitor_ascensori(10,2);
    public Ascensore ascensori[];

    /**
     * Classe che viene eseguita ad ogni frame visualizzato dall'applet.
     * La velocit di aggiornamento dei frame dipende dal delay che viene stabilito per il timer
     * nella procedura init();
     * In questo metodo vengono disegnati gli ascensori ogni volta che si muovono e vengono disegnate tutte
     * le persone che entrano negli ascensori.
     */

    public void redraw(){
	// movimento ascensori


	if (piani[monitor_globale.pianoascensore[0]] > ascensore1from)
	    {
		if ( Math.abs(   piani[monitor_globale.pianoascensore[0]] - doveascensore1 - 12)  > 2 )
		    {
			doveascensore1 = ascensore1from - 12 + ((frameNumber1) % (   piani[monitor_globale.pianoascensore[0]] - ascensore1from) );
			Asc1Label.setLocation(143, doveascensore1);
			Asc1LabelText.setText(String.valueOf(5 -monitor_globale.postiascensore[0]));
			Asc1LabelText.setLocation(148, doveascensore1 + 5);
		    } else {

			monitor_globale.disegna[0]=true;
			frameNumber1 = 0;
			ascensore1from =   piani[monitor_globale.pianoascensore[0]];
		    }
	    } else if (   piani[monitor_globale.pianoascensore[0]] < ascensore1from)
		{

		    if ( Math.abs(   piani[monitor_globale.pianoascensore[0]] - doveascensore1 - 12) > 2 )
			{
			    doveascensore1 = ascensore1from - 12 - ((frameNumber1) % (ascensore1from -    piani[monitor_globale.pianoascensore[0]]) );
			    Asc1Label.setLocation(143, doveascensore1);
			    Asc1LabelText.setText(String.valueOf(5 -monitor_globale.postiascensore[0]));
			    Asc1LabelText.setLocation(148, doveascensore1 + 5);

			} else {
			    monitor_globale.disegna[0]=true;
			    frameNumber1 = 0;
			    ascensore1from =   piani[monitor_globale.pianoascensore[0]];
			}
		} else {

		    Asc1Label.setLocation(143,    piani[monitor_globale.pianoascensore[0]] -12);
		    Asc1LabelText.setText(String.valueOf(5 -monitor_globale.postiascensore[0]));
		    Asc1LabelText.setLocation(148,    piani[monitor_globale.pianoascensore[0]] + 5 -12);
		}

	if (piani[monitor_globale.pianoascensore[1]] > ascensore2from)
	    {
		if ( Math.abs(   piani[monitor_globale.pianoascensore[1]] - doveascensore2 - 12)  > 2 )
		    {

			doveascensore2 = ascensore2from - 12 + ((frameNumber) % (   piani[monitor_globale.pianoascensore[1]] - ascensore2from) );
			Asc2Label.setLocation(522, doveascensore2);
			Asc2LabelText.setText(String.valueOf(5 -monitor_globale.postiascensore[1]));
			Asc2LabelText.setLocation(527, doveascensore2 + 5);
		    } else {
			monitor_globale.disegna[1]=true;
			frameNumber = 0;
			ascensore2from =   piani[monitor_globale.pianoascensore[1]];
		    }
	    } else if (   piani[monitor_globale.pianoascensore[1]] < ascensore2from)
		{

		    if ( Math.abs(   piani[monitor_globale.pianoascensore[1]] - doveascensore2 - 12) > 2 )
			{
			    doveascensore2 = ascensore2from - 12 - ((frameNumber) % (ascensore2from -    piani[monitor_globale.pianoascensore[1]]) );
			    Asc2Label.setLocation(522, doveascensore2);
			    Asc2LabelText.setText(String.valueOf(5 -monitor_globale.postiascensore[1]));
			    Asc2LabelText.setLocation(527, doveascensore2 + 5);

			} else {

			    monitor_globale.disegna[1]=true;
			    frameNumber = 0;
			    ascensore2from =   piani[monitor_globale.pianoascensore[1]];
			}
		} else {

		    Asc2Label.setLocation(522,    piani[monitor_globale.pianoascensore[1]] -12);
		    Asc2LabelText.setText(String.valueOf(5 -monitor_globale.postiascensore[1]));
		    Asc2LabelText.setLocation(527,    piani[monitor_globale.pianoascensore[1]] + 5 -12);

		}

	//movimento persone

	for ( j = 0; j < numpersone; j++) {

	    if (persone[j].muove) {
		if (persone[j].x == persone[j].xpartenza) {

		    layeredPane.remove(persone[j].PersonaLabel);
		    persone[j].Immagine = getImage(getCodeBase(), persone[j].imagefile);
		    tempicon = new ImageIcon(persone[j].Immagine);
		    persone[j].PersonaIcon = tempicon;
		    persone[j].PersonaLabel = new JLabel(persone[j].PersonaIcon);
		    persone[j].Width = persone[j].PersonaIcon.getIconWidth();
		    persone[j].Height = persone[j].PersonaIcon.getIconHeight();
		    persone[j].PersonaLabel.setBounds(-persone[j].Width, -persone[j].Height, persone[j].Width, persone[j].Height);
		    persone[j].PersonaLabel.setLocation(persone[j].xpartenza, piani[persone[j].piano_from]);
		    layeredPane.add(persone[j].PersonaLabel);
		    layeredPane.setLayer(persone[j].PersonaLabel, 0);

		}

		if (persone[j].id_asc == 0 )
		    {


			if ( ( persone[j].x - 143 ) > 2 )
			    {
				persone[j].x = persone[j].xpartenza - ((framePerson)  %  (persone[j].xpartenza - 143) );
				persone[j].PersonaLabel.setLocation(persone[j].x, piani[persone[j].piano_from]);
				persone[j].TextLabel.setLocation(persone[j].x, piani[persone[j].piano_from] - 10);

			    } else
				{
				    layeredPane.remove(persone[j].PersonaLabel);
				    layeredPane.remove(persone[j].TextLabel);
				    persone[j].muove = false ;
				    Asc1Label.setLocation(143,    piani[monitor_globale.pianoascensore[0]] -12);
				    Asc1LabelText.setText(String.valueOf(5 -monitor_globale.postiascensore[0]));
				    Asc1LabelText.setLocation(148,    piani[monitor_globale.pianoascensore[0]] + 5 -12);

				}
		    }
		else
		    {
			if ( (522 -  persone[j].x) > 2 )
			    {
				persone[j].x = persone[j].xpartenza + ((framePerson ) % ( 522 - persone[j].xpartenza) );
				persone[j].PersonaLabel.setLocation(persone[j].x, piani[persone[j].piano_from]);
				persone[j].TextLabel.setLocation(persone[j].x, piani[persone[j].piano_from] - 10);
			    } else
				{
				    layeredPane.remove(persone[j].PersonaLabel);
				    layeredPane.remove(persone[j].TextLabel);
				    persone[j].muove = false;
				    Asc2Label.setLocation(522,    piani[monitor_globale.pianoascensore[1]] - 12);
				    Asc2LabelText.setText(String.valueOf(5 -monitor_globale.postiascensore[1]));
				    Asc2LabelText.setLocation(527,    piani[monitor_globale.pianoascensore[1]] + 5 -12);
				}
		    }
	    }
	}
    }

    /**
     *  Inserisce un'immagine all'interno dell'applet.
     *  Permette di indicare dimensioni, posizionamento e livello dove inserire l'immagine
     *
     *  @param JPanel1 Contenitore a livelli nel quale inserire l'immagine
     *  @param img  Immagine da inserire
     *  @param x  Ascissa di posizione dell'immagine
     *  @param y  Ordinata di posizione dell'immagine
     *  @param w  Larghezza dell'immagine
     *  @param h  Altezza dell'immagine
     *  @param Layer Livello nel quale inserire l'immagine
     *  @param isopaque  Booleano che indica se l'immagine deve essere posizionata su un livello trasparente
     */

    public JLabel InsertIcon( JLayeredPane jPanel1, Image img, int x, int y, int w, int h, int Layer, boolean isopaque) {

        final ImageIcon Icona = new ImageIcon(img);
        JLabel Label1 = new JLabel(Icona);
        Label1.setOpaque(isopaque);
        Label1.setBounds(x, y, w, h);
        layeredPane.add(Label1);
        layeredPane.setLayer(Label1, Layer);
        return Label1;
    }

    /**
     * Inizializza una coppia di pulsanti per l'inserimento delle persone
     * @param Jpanel1 Contenitore a livelli nel quale inserire il pulsante
     * @param jbuttonsu Pulsante per l'inserimento di persone con direzione verso l'alto.
     * @param jbuttongiu Pulsante per l'inserimento di persone con direzione verso il basso.
     * @param n Indice di posizionamento, da zero a 10
     * @param startpix Numero di pixel verticali che distanziano il primo pulsante dal top dell'applet
     */

    public void initbutts (JLayeredPane jPanel1, JButton jbuttonsu, JButton jbuttongiu, int n, int startpix) {
	int buttsize = 46;  //size of the floor
	if (n == 0) {
	    jbuttongiu.reshape(0, (startpix + n*buttsize),2*buttsize, buttsize);
	    jbuttongiu.setIcon(FrecciaIconGiu);
	    jPanel1.add(jbuttongiu, null);
	} else if (n==9) {

	    jbuttonsu.setIcon(FrecciaIconSu);
	    jbuttonsu.reshape(0, (startpix + n*buttsize),2*buttsize, buttsize);
	    jPanel1.add(jbuttonsu, null);
	} else {

	    jbuttonsu.setIcon(FrecciaIconSu);
	    jbuttonsu.reshape(0, (startpix + n*buttsize),buttsize, buttsize);
	    jbuttongiu.reshape(buttsize, (startpix + n*buttsize),buttsize, buttsize);
	    jbuttongiu.setIcon(FrecciaIconGiu);
	    jPanel1.add(jbuttonsu, null);
	    jPanel1.add(jbuttongiu, null);
	}
    }

    /**
     * Metodo di inizializzazione dell'applet.
     * Questo metodo  eseguito solo una volta, all'avvio dell'applet. Se viene premuto il pulsante reload del
     * browser viene rieseguito anche questo metodo.
     * Contiene tutte le istanze necessarie a far partire l'applet.
     */

    public void init() {

        Font font1 = new Font("Verdana", Font.BOLD, 12);
        int startpix = 70;  //space between the first floor from top and top of the image
        Image bgImage = getImage(getCodeBase(), sfondo);
        Image ascens1 = getImage(getCodeBase(), asce1);
        Image ascens2 = getImage(getCodeBase(), asce2);
        Image IconImageSu = getImage(getCodeBase(),"frecciasu.gif");
        Image IconImageGiu = getImage(getCodeBase(),"frecciagiu.gif");

        // to show the background
        jPanel1.setOpaque(false);

        // to set the bgcolor
        this.getContentPane().setBackground(Color.white);

        // to add the action listener for every button
        jButton1giu.addActionListener(this);
        jButton2giu.addActionListener(this);
        jButton2su.addActionListener(this);
        jButton3giu.addActionListener(this);
        jButton3su.addActionListener(this);
        jButton4giu.addActionListener(this);
        jButton4su.addActionListener(this);
        jButton5giu.addActionListener(this);
        jButton5su.addActionListener(this);
        jButton6giu.addActionListener(this);
        jButton6su.addActionListener(this);
        jButton7giu.addActionListener(this);
        jButton7su.addActionListener(this);
        jButton8giu.addActionListener(this);
        jButton8su.addActionListener(this);
        jButton9giu.addActionListener(this);
        jButton9su.addActionListener(this);
        jButton10su.addActionListener(this);

        //Create the layered pane to hold the labels.
        layeredPane = new JLayeredPane();

        // to insert the background
        InsertIcon(layeredPane, bgImage, 92, 0, 500, 575, -1, true);

        FrecciaIconSu = new ImageIcon(IconImageSu);
        FrecciaIconGiu = new ImageIcon(IconImageGiu);

        final ImageIcon ascIcon = new ImageIcon(ascens1);
        ascIconWidth = ascIcon.getIconWidth();
        ascIconHeight = ascIcon.getIconHeight();
        //Create a label to display the foreground image.
        Asc1Label = new JLabel(ascIcon);
        Asc1Label.setBounds( -ascIconWidth, -ascIconHeight, ascIconWidth, ascIconHeight);

        final ImageIcon ascIcon2 = new ImageIcon(ascens2);
        //Create a label to display the foreground image.
        Asc2Label = new JLabel(ascIcon2);
        Asc2Label.setBounds(-ascIconWidth, -ascIconHeight, ascIconWidth, ascIconHeight);


        Asc1LabelText = new JLabel();
        Asc1LabelText.setText(String.valueOf(dentroa1));
        Asc1LabelText.setBounds(-10, -10, 10, 10);
        Asc1LabelText.setFont(font1);

        Asc2LabelText = new JLabel();
        Asc2LabelText.setText(String.valueOf(dentroa2));
        Asc2LabelText.setBounds(-10, -10, 10, 10);
        Asc2LabelText.setFont(font1);

	/* inserisce i pulsanti */
        Auto.setText("Auto");
        Auto.reshape(0, 0, 92, startpix);


        //Set up a timer that calls this object's action handler
        timer = new javax.swing.Timer(20, this); //delay = 20 ms
        timer.setInitialDelay(0);
        timer.setCoalesce(true);




        layeredPane.add(Auto);
        layeredPane.setLayer(Auto, 1);
        layeredPane.add(Asc1Label);
        layeredPane.setLayer(Asc1Label, 1);
        layeredPane.add(Asc2Label, 1);
        layeredPane.setLayer(Asc2Label, 1);
        layeredPane.add(Asc1LabelText, 100);
        layeredPane.setLayer(Asc1LabelText, 100);
        layeredPane.add(Asc2LabelText, 100);
        layeredPane.setLayer(Asc2LabelText, 100);

        initbutts(layeredPane, jButton1giu, jButton1giu, 0, startpix);
        initbutts(layeredPane, jButton2su, jButton2giu, 1, startpix);
        initbutts(layeredPane, jButton3su, jButton3giu, 2, startpix);
        initbutts(layeredPane, jButton4su, jButton4giu, 3, startpix);
        initbutts(layeredPane, jButton5su, jButton5giu, 4, startpix);
        initbutts(layeredPane, jButton6su, jButton6giu, 5, startpix);
        initbutts(layeredPane, jButton7su, jButton7giu, 6, startpix);
        initbutts(layeredPane, jButton8su, jButton8giu, 7, startpix);
        initbutts(layeredPane, jButton9su, jButton9giu, 8, startpix);
        initbutts(layeredPane, jButton10su, jButton10su, 9, startpix);
        this.getContentPane().add(layeredPane, BorderLayout.CENTER);




        // start of the monitor

        monitor_globale=new monitor_ascensori(npiani,2);
        ascensori=new Ascensore[2];

	persone= new persona[maxpersone];

        ascensori[0]=new Ascensore(monitor_globale,0);
        ascensori[1]=new Ascensore(monitor_globale,1);

	ascensori[0].start();
	ascensori[1].start();


        // ultime modifiche
    }

    //Invoked by the applet browser only.
    /**
     * Metodo d'inizio dell'applet, eseguito solo dal browser dopo init.
     */

    public void start() {
        startAnimation();
    }

   /**
     * Metodo di stop dell'applet, eseguito solo dal browser.
     */

    public void stop() {
        stopAnimation();
    }

    /**
     * Metodo di inizio dell'animazione.
     */

    public synchronized void startAnimation() {
        if (frozen) {
            //Do nothing.  The user has requested that we
            //stop changing the image.
        } else {
            //Start animating!
            if (!timer.isRunning()) {
                timer.start();
            }
        }
    }

    /**
     * Metodo che termina l'animazione.
     */

    public synchronized void stopAnimation() {
        //Stop the animating thread.
        if (timer.isRunning()) {
            timer.stop();
        }
    }

   /**
    * Metodo per la creazione dei nuovi thread persone.
    * Ogni oggetto persona contiene, oltre alle variabili private, vari oggetti che servono alla sua
    * graficazione all'interno dell'applet.
    * @param npiani Numero di piani del palazzo
    * @param monitor_ascensori Monitor che gestisce la concorrenza delle persone
    * @param piano Piano di partenza della persona
    * @param direzione Direzione (1 = gi, 3 = su) della persona creata
    */

    public void creapersona(int npiani, monitor_ascensori monitor_globale, int piano, int direzione){

            persone[numpersone] = new persona(npiani, monitor_globale,numpersone,piano,direzione);
            persone[numpersone].start();
	    persone[numpersone].Immagine = getImage(getCodeBase(), persone[numpersone].imagefile);
            tempicon = new ImageIcon(persone[numpersone].Immagine);
            persone[numpersone].PersonaIcon = tempicon;
            persone[numpersone].PersonaLabel = new JLabel(persone[numpersone].PersonaIcon);
            persone[numpersone].Width = persone[numpersone].PersonaIcon.getIconWidth();
            persone[numpersone].Height = persone[numpersone].PersonaIcon.getIconHeight();
            persone[numpersone].PersonaLabel.setBounds(-persone[numpersone].Width, -persone[numpersone].Height, persone[numpersone].Width, persone[numpersone].Height);
            persone[numpersone].PersonaLabel.setLocation(persone[numpersone].xpartenza, piani[persone[numpersone].piano_from]);
            persone[j].x = persone[j].xpartenza;
            layeredPane.add(persone[numpersone].PersonaLabel);
            layeredPane.setLayer(persone[numpersone].PersonaLabel, 0);
            persone[numpersone].TextLabel.setLocation(persone[numpersone].xpartenza, piani[persone[numpersone].piano_from] - 10);
            layeredPane.add(persone[numpersone].TextLabel, 1);
            layeredPane.setLayer(persone[numpersone].TextLabel, 1);
            numpersone++;
    }

    /**
     * Metodo che gestisce gli interrupt dell'applet.
     * Gli eventi che generano gli interrupt sono prodotti dal timer o dai pulsanti di creazione
     * delle persone. Ogni volta che il timer genera l'evento viene eseguita la procedura redraw()     * per ridisegnare la schermata.
     * @param e Evento che ha generato l'interrupt
     */

    public void actionPerformed(ActionEvent e) {
	Object source = new Object();
	source = e.getSource();

        if (e.getSource() == timer) {
	    //Advance animation frame.
	    if (((frameNumber % 100) == 0)  && ( Auto.isSelected() == true) )
		//              if( Auto.isSelected() == true)
		{
		    pianofrom = (int) (Math.random() * 10 );
		    if (pianofrom == 0 ) {direzione = 3;} else
			if (pianofrom == 9) {direzione = 1;} else
			    direzione = (((int) (Math.random() * 2)) *2 ) + 1;
		    creapersona(npiani,monitor_globale,pianofrom,direzione);
		}
	    frameNumber++;
	    frameNumber1++;
	    framePerson++;
	    //Display it.
	    redraw();

        } else


	    if (e.getSource() == jButton1giu) {
		creapersona(npiani,monitor_globale,9,1);

	    } else
		if (e.getSource() == jButton2su) {
		    creapersona(npiani,monitor_globale,8, 3);
		}  else
		    if (e.getSource() == jButton2giu) {
			creapersona(npiani,monitor_globale,8,1);
		    } else
			if (e.getSource() == jButton3su) {
			    creapersona(npiani,monitor_globale,7,3);
			} else
			    if (e.getSource() == jButton3giu) {
				creapersona(npiani,monitor_globale,7,1);
			    } else
				if (e.getSource() == jButton4su) {
				    creapersona(npiani,monitor_globale,6,3);
				} else
				    if (e.getSource() == jButton4giu) {
					creapersona(npiani,monitor_globale,6,1);
				    } else
					if (e.getSource() == jButton5su) {
					    creapersona(npiani,monitor_globale,5,3);
					} else
					    if (e.getSource() == jButton5giu) {
						creapersona(npiani,monitor_globale,5,1);
					    } else
						if (e.getSource() == jButton6su) {
						    creapersona(npiani,monitor_globale,4,3);
						} else
						    if (e.getSource() == jButton6giu) {
							creapersona(npiani,monitor_globale,4,1);
						    } else
							if (e.getSource() == jButton7su) {
							    creapersona(npiani,monitor_globale,3,3);
							} else
							    if (e.getSource() == jButton7giu) {
								creapersona(npiani,monitor_globale,3,1);
							    } else
								if (e.getSource() == jButton8su) {
								    creapersona(npiani,monitor_globale,2,3);
								} else
								    if (e.getSource() == jButton8giu) {
									creapersona(npiani,monitor_globale,2,1);
								    } else
									if (e.getSource() == jButton9su) {
									    creapersona(npiani,monitor_globale,1,3);
									} else
									    if (e.getSource() == jButton9giu) {
										creapersona(npiani,monitor_globale,1,1);
									    } else
										if (e.getSource() == jButton10su) {
										    creapersona(npiani,monitor_globale,0,3);
										}
    }
}
